/*
 * This file is part of the OpenKinect Project. http://www.openkinect.org
 *
 * Copyright (c) 2010 individual OpenKinect contributors. See the CONTRIB file
 * for details.
 *
 * This code is licensed to you under the terms of the Apache License, version
 * 2.0, or, at your option, the terms of the GNU General Public License,
 * version 2.0. See the APACHE20 and GPL2 files for the text of the licenses,
 * or the following URLs:
 * http://www.apache.org/licenses/LICENSE-2.0
 * http://www.gnu.org/licenses/gpl-2.0.txt
 *
 * If you redistribute this file in source form, modified or unmodified, you
 * may:
 *   1) Leave this header intact and distribute it under the same terms,
 *      accompanying it with the APACHE20 and GPL20 files, or
 *   2) Delete the Apache 2.0 clause and accompany it with the GPL2 file, or
 *   3) Delete the GPL v2 clause and accompany it with the APACHE20 file
 * In all cases you must keep the copyright notice intact and include a copy
 * of the CONTRIB file.
 *
 * Binary distributions must follow the binary distribution requirements of
 * either License.
 */

import org.openkinect.Image;

import java.awt.image.BufferedImage;

import java.nio.ByteBuffer;
import java.nio.ShortBuffer;


/*
* To change this template, choose Tools | Templates
* and open the template in the editor.
 */

/**
 *
 * @author richard
 */
public class DepthImage implements Image {

  /** TODO Field description */
  public static final int HEIGHT = 480;

  /** TODO Field description */
  public static final int WIDTH = 640;

  /** TODO Field description */
  private ShortBuffer data;

  /**
   * TODO Method description
   *
   * @param depthBuffer
   */
  public void data(ByteBuffer depthBuffer) {
    data = depthBuffer.asShortBuffer();
  } // constructor

  /**
   * TODO Method description
   *
   * @return
   */
  public ShortBuffer getData() {
    return data;
  }

  /**
   * TODO Method description
   *
   * @return
   */
  public BufferedImage getImage() {
    BufferedImage depth = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_3BYTE_BGR);

    for (int y = 0; y < HEIGHT; y++) {
      for (int x = 0; x < WIDTH; x++) {
        int   offset = (y * WIDTH + x);
        short d      = data.get(offset);
        int   pixel  = depth2rgb(d);
        depth.setRGB(x, y, pixel);
      } // for
    } // for

    return depth;
  } // getImage

  /**
   * TODO Method description
   *
   * @param depth
   * @return
   */
  public int depth2rgb(short depth) {
    int   r, g, b;

    float v = depth / 2047f;
    v = (float) Math.pow(v, 3) * 6;
    v = v * 6 * 256;

    int pval = Math.round(v);
    int lb   = pval & 0xff;
    switch (pval >> 8) {

    case 0:
      b = 255;
      g = 255 - lb;
      r = 255 - lb;
      break;

    case 1:
      b = 255;
      g = lb;
      r = 0;
      break;

    case 2:
      b = 255 - lb;
      g = 255;
      r = 0;
      break;

    case 3:
      b = 0;
      g = 255;
      r = lb;
      break;

    case 4:
      b = 0;
      g = 255 - lb;
      r = 255;
      break;

    case 5:
      b = 0;
      g = 0;
      r = 255 - lb;
      break;

    default:
      r = 0;
      g = 0;
      b = 0;
      break;
    }

    int pixel = (0xFF) << 24 | (b & 0xFF) << 16 | (g & 0xFF) << 8 | (r & 0xFF) << 0;

    return pixel;
  }
} // DepthImage


