/*
 * This file is part of the OpenKinect Project. http://www.openkinect.org
 *
 * Copyright (c) 2010 individual OpenKinect contributors. See the CONTRIB file
 * for details.
 *
 * This code is licensed to you under the terms of the Apache License, version
 * 2.0, or, at your option, the terms of the GNU General Public License,
 * version 2.0. See the APACHE20 and GPL2 files for the text of the licenses,
 * or the following URLs:
 * http://www.apache.org/licenses/LICENSE-2.0
 * http://www.gnu.org/licenses/gpl-2.0.txt
 *
 * If you redistribute this file in source form, modified or unmodified, you
 * may:
 *   1) Leave this header intact and distribute it under the same terms,
 *      accompanying it with the APACHE20 and GPL20 files, or
 *   2) Delete the Apache 2.0 clause and accompany it with the GPL2 file, or
 *   3) Delete the GPL v2 clause and accompany it with the APACHE20 file
 * In all cases you must keep the copyright notice intact and include a copy
 * of the CONTRIB file.
 *
 * Binary distributions must follow the binary distribution requirements of
 * either License.
 */

import org.openkinect.Context;
import org.openkinect.Device;
import org.openkinect.LEDStatus;

import java.io.IOException;


/**
 * @author Michael Nischt
 */
public class Example2 {

  /**
   * TODO Method description
   *
   * @param args
   * @throws IOException
   * @throws InterruptedException
   */
  public static void main(String[] args) throws IOException, InterruptedException {
    Context context = Context.getContext();

    if (context.devices() < 1) {
      System.out.println("No Kinect devices found.");
      return;
    }

    Device device = context.getDevice(0);

    device.light(LEDStatus.LED_BLINK_RED_YELLOW);

    float degrees = -27;
    device.tilt(degrees);
    Thread.sleep(2000);

    while (degrees < 27) {
      device.tilt(degrees);
      Thread.sleep(100);
      degrees = degrees + 1;
    }

    device.tilt(-27);
    Thread.sleep(3000);
    device.tilt(27);
    Thread.sleep(3000);
    device.tilt(0);
    device.light(LEDStatus.LED_OFF);
  }
}

