/*
 * This file is part of the OpenKinect Project. http://www.openkinect.org
 *
 * Copyright (c) 2010 individual OpenKinect contributors. See the CONTRIB file
 * for details.
 *
 * This code is licensed to you under the terms of the Apache License, version
 * 2.0, or, at your option, the terms of the GNU General Public License,
 * version 2.0. See the APACHE20 and GPL2 files for the text of the licenses,
 * or the following URLs:
 * http://www.apache.org/licenses/LICENSE-2.0
 * http://www.gnu.org/licenses/gpl-2.0.txt
 *
 * If you redistribute this file in source form, modified or unmodified, you
 * may:
 *   1) Leave this header intact and distribute it under the same terms,
 *      accompanying it with the APACHE20 and GPL20 files, or
 *   2) Delete the Apache 2.0 clause and accompany it with the GPL2 file, or
 *   3) Delete the GPL v2 clause and accompany it with the APACHE20 file
 * In all cases you must keep the copyright notice intact and include a copy
 * of the CONTRIB file.
 *
 * Binary distributions must follow the binary distribution requirements of
 * either License.
 */

import org.openkinect.Image;

import java.awt.image.BufferedImage;

import java.nio.ByteBuffer;


/**
 * Class description
 *
 *
 * @version        Enter version here..., 2011.04.11 at 12:23:05 CDT
 * @author         Enter your name here...    
 */
public class VideoImage implements Image {

  /** TODO Field description */
  public static final int HEIGHT = 480;

  /** TODO Field description */
  public static final int WIDTH = 640;

  /** TODO Field description */
  public ByteBuffer data;

  /**
   * TODO Method description
   *
   * @param videoBuffer
   */
  public void data(ByteBuffer videoBuffer) {
    data = videoBuffer;
  } // constructor

  /**
   * TODO Method description
   *
   * @return
   */
  public ByteBuffer getData() {
    return data;
  }

  /**
   * TODO Method description
   *
   * @return
   */
  public BufferedImage getImage() {
    BufferedImage video = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_3BYTE_BGR);

    for (int y = 0; y < HEIGHT; y++) {
      for (int x = 0; x < WIDTH; x++) {
        int offset = 3 * (y * WIDTH + x);

        int r      = data.get(offset + 2) & 0xFF;
        int g      = data.get(offset + 1) & 0xFF;
        int b      = data.get(offset + 0) & 0xFF;

        int pixel  = (0xFF) << 24 | (b & 0xFF) << 16 | (g & 0xFF) << 8 | (r & 0xFF) << 0;
        video.setRGB(x, y, pixel);
      }
    }

    return video;
  } // getImage
} // VideoImage


